use $(LIBENSCVECTOR) instead of libensc_vector.a
[util-vserver.git] / util-vserver / scripts / chcontext
index dbb7ab4..3ca4aa2 100755 (executable)
@@ -18,7 +18,7 @@
 
 : ${UTIL_VSERVER_VARS:=/usr/lib/util-vserver/util-vserver-vars}
 test -e "$UTIL_VSERVER_VARS" || {
-    echo "Can not find util-vserver installation; aborting..." >&2
+    echo $"Can not find util-vserver installation (the file '$UTIL_VSERVER_VARS' would be expected); aborting..." >&2
     exit 1
 }
 . "$UTIL_VSERVER_VARS"
@@ -27,7 +27,7 @@ test -e "$UTIL_VSERVER_VARS" || {
 function showHelp()
 {
     echo \
-$"Usage: /usr/sbin/chcontext [--cap [!]<cap_name>] [--secure] [--ctx <num>] [--disconnect]
+$"Usage: /usr/sbin/chcontext [--cap [!]<cap_name>] [--secure] [--xid <num>] [--disconnect]
        [--domainname <name>] [--hostname <name>] [--flag <flags>+]
        [--silent] [--] command arguments ...
 
@@ -48,12 +48,12 @@ By default, a new/unused context is allocated
     repeated several time.
     See /usr/include/linux/capability.h
 
---ctx num
+--xid num
     Select the context. On root in context 0 is allowed to
     select a specific context.
     Context number 1 is special. It can see all processes
     in any contexts, but can't kill them though.
-    Option --ctx may be repeated several times to specify up to 16 contexts.
+    Option --xid may be repeated several times to specify up to 16 contexts.
 --disconnect
     Start the command in background and make the process
     a child of process 1.
@@ -101,7 +101,7 @@ the GNU General Public License.  This program has absolutely no warranty."
 
 $_VSERVER_INFO - FEATURE migrate || exec $_CHCONTEXT_COMPAT "$@"
 
-tmp=$(getopt -o + --long cap:,ctx:,disconnect,domainname:,flag:,hostname:,secure,silent,help,version -n "$0" -- "$@") || exit 1
+tmp=$(getopt -o + --long cap:,ctx:,xid:,disconnect,domainname:,flag:,hostname:,secure,silent,help,version -n "$0" -- "$@") || exit 1
 eval set -- "$tmp"
 
 OPT_CAPS=()
@@ -110,17 +110,22 @@ OPT_DISCONNECT=
 OPT_FLAGS=()
 OPT_SECURE=
 OPT_SILENT=
+OPT_INITPID=
 
 while true; do
     case "$1" in
        --help)         showHelp $0 ;;
        --version)      showVersion ;;
        --cap)          OPT_CAPS=( "${OPT_CAPS[@]}" "$2" ); shift;;
-       --ctx)          OPT_CTX=$2; shift;;
+       --ctx|--xid)    OPT_CTX=$2; shift;;
        --disconnect)   OPT_DISCONNECT=1;;
        --domainname)   OPT_DOMAINNAME=$2; shift;;
        --hostname)     OPT_HOSTNAME=$2;   shift;;
-       --flag)         OPT_FLAGS=( "${OPT_FLAGS[@]}" "$2" ); shift;;
+       --flag)
+           test "$2" != "fakeinit" || OPT_INITPID=--initpid
+           OPT_FLAGS=( "${OPT_FLAGS[@]}" "$2" )
+           shift
+           ;;
        --secure)       OPT_SECURE=1;;
        --silent)       OPT_SILENT=1;;
        --)             shift; break;;
@@ -129,32 +134,43 @@ while true; do
     shift
 done
 
-create_cmd=( $_VCONTEXT --create
+create_cmd=( $_VCONTEXT --create --silentexist
             ${OPT_SILENT:+--silent}
             ${OPT_CTX:+--xid "$OPT_CTX"} )
 
 chain_cmd=()
-test -z "$OPT_CAPS$OPT_FLAGS$OPT_SECURE" || \
-    chain_cmd=( "${chain_cmd[@]}"
-               --
-               $_VATTRIBUTE --set
-               ${OPT_CAPS:+--cap "${OPT_CAPS[@]}"}
-               ${OPT_FLAGS:+--flag "${OPT_FLAGS[@]}"}
-               ${OPT_SECURE:+--secure} )
+
+old_IFS=$IFS
+IFS=,$IFS
 
 test -z "$OPT_DOMAINNAME$OPT_HOSTNAME" || \
     chain_cmd=( "${chain_cmd[@]}"
                --
-               $_VUNAME -s
-               ${OPT_DOMAINNAME:+--domainname "$OPT_DOMAINNAME"}
-               ${OPT_HOSTNAME:+--nodename "$OPT_HOSTNAME"} )
+               $_VUNAME --set --xid self
+               ${OPT_DOMAINNAME:+-t domainname="$OPT_DOMAINNAME"}
+               ${OPT_HOSTNAME:+  -t nodename="$OPT_HOSTNAME"} )
 
+chain_cmd=( "${chain_cmd[@]}"
+               --
+               $_VATTRIBUTE --set
+               ${OPT_CAPS:+--bcap "${OPT_CAPS[*]}"}
+               ${OPT_FLAGS:+--flag "${OPT_FLAGS[*]}"}
+               ${OPT_SECURE:+--secure} )
+               
 migrate_cmd=( $_VCONTEXT
              ${OPT_SILENT:+--silent}
-             ${OPT_DISCONNECT:+--disconnect} )
+             ${OPT_DISCONNECT:+--disconnect}
+             $OPT_INITPID )
+
+IFS=$old_IFS
 
-"${create_cmd[@]}" "${chain_cmd[@]}" -- "${migrate_cmd[@]}" --migrate-self -- "$@"
-rc=$?
+if $_VSERVER_INFO -q "$OPT_CTX" XIDTYPE static; then
+    "${create_cmd[@]}" "${chain_cmd[@]}" -- \
+       "${migrate_cmd[@]}" --endsetup --migrate-self -- "$@"
+    rc=$?
+else
+    rc=254
+fi
 
-test "$rc" -ne 254 || exec "${migrate_cmd[@]}" --migrate -- "$@"
+test "$rc" -ne 254 || exec "${migrate_cmd[@]}" --xid "$OPT_CTX" --migrate -- "$@"
 exit $rc